dnl Copyright (c) 2008 Q2S NTNU, Trondheim, Norway
dnl All rights reserved.
dnl
dnl This program is free software; you can redistribute it and/or modify
dnl it under the terms of the GNU General Public License version 2 as
dnl published by the Free Software Foundation;
dnl
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
dnl GNU General Public License for more details.
dnl
dnl You should have received a copy of the GNU General Public License
dnl along with this program; if not, write to the Free Software
dnl Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
dnl
dnl Author: Laurent Paquereau <laurent.paquereau@q2s.ntnu.no>
dnl
dnl $Header$

dnl --with-tclcl option. This is to be able to specify a given tclcl directory

AC_DEFUN([AC_TCLCLDIR], [

AC_ARG_WITH([tclcl],
	[AC_HELP_STRING([--with-tclcl=<dir>],
			[use tclcl installation in <directory> (default is guessed from NSALLINONEDIR)])],
	[
	    if test ! -d $withval 
		then
		AC_MSG_ERROR([tclcl directory $withval is not valid])
	    else
		TCLCLDIR=$withval
		TCLCL_DISTCHECK_CONFIGURE_FLAGS="--with-tclcl=$withval"
		AC_SUBST(TCLCL_DISTCHECK_CONFIGURE_FLAGS)

	    fi
	])

if test x$TCLCLDIR = x ;    then
	TCLCLDIR=$NSALLINONEDIR/`cd $NSALLINONEDIR; ls -d tclcl-* | head -n 1`
fi

AC_MSG_RESULT([setting TCLCLDIR to $TCLCLDIR])

AC_ARG_VAR([TCL2CPP],[tcl2c++ executable])
AC_PATH_PROG([TCL2CPP],[tcl2c++],[none],[$PATH:$TCLCLDIR])
if test "x$TCL2CPP" = "xnone" ;    then
	AC_MSG_ERROR([could not find tcl2c++])
fi

])
