#
#
# S c e n a r i o   t o   g e n e r a t e   a n d 
# d i s p l a y   t o p o l o g i e s   i n   n a m 
#
# Creates a nam trace file just showing the topology.
#
# OW 2005-02-15
# - Created, based on ANCreateTopo_scenario.tcl from ns2.1b6 patch.
#

#   
# Default constants and parameters
#
set TopologyPath         "../../topologies"
set LibPath              "."
set ClassLibPath         "."
set param(DEBUG_ON)          0
set param(TRACE_ON)          1
set param(NAMTRACE_ON)       1

#set param(Topology)      "$TopologyPath/topo_ring.tcl"   ;# 10 node ring network with some redundancy 
#set param(Topology)      "$TopologyPath/topo_1.tcl"     ;# 20 node random network
#set param(Topology)      "$TopologyPath/topo_3.tcl"      ;# 10 node random network
#set param(Topology)      "$TopologyPath/topo_boltztest.tcl"      ;# 6 node fully meshed
#set param(Topology)      "$TopologyPath/topo_4.tcl"      ;# 40 node random network
#set param(Topology)      "$TopologyPath/topo_ftv47.tcl"  ;# 48 node fully meshed network with reported best tour = 1776 ms
#set param(Topology)      "$TopologyPath/topo_ft53.tcl"   ;# 53 node fully meshed network with reported best tour = 6905 ms
#set param(Topology)      "$TopologyPath/topo_debug.tcl"  ;# simple 8 node network for debugging
#set param(Topology)      "$TopologyPath/topo_fri26.tcl"  ;# 26 node fully meshed network with reported best tour = 937 ms (80000)
#set param(Topology)      "$TopologyPath/topo_gr17.tcl"   ;# 17 node fully meshed network with reported best tour = 2085 ms
#set param(Topology)      "$TopologyPath/topo_gr21.tcl"   ;# 21 node fully meshed network with reported best tour = 2707 ms
#set param(Topology)      "$TopologyPath/topo_gr24.tcl"   ;# 24 node fully meshed network with reported best tour = 1272 ms
#set param(Topology)      "$TopologyPath/topo_bayg29.tcl" ;# 29 node fully meshed network with reported best tour = 1610 ms
#set param(Topology)      "$TopologyPath/topo_bays29.tcl" ;# 29 node fully meshed network with reported best tour = 2020 ms
#set param(Topology)      "$TopologyPath/topo_ry48p.tcl" ;# 48 node fully meshed network with reported best tour = 14422 ms
#set param(Topology)      "$TopologyPath/topo_kro124p.tcl" ;# 100 node fully meshed network with reported best tour =  36230 ms
#set param(Topology)      "$TopologyPath/topo_A26.tcl" ;# 26 node random generated network with high redundancy
#set param(Topology)      "$TopologyPath/topo_B26.tcl" ;# 26 node random generated network with medium redundancy
#set param(Topology)      "$TopologyPath/topo_C26.tcl" ;# 26 node random generated network with low redundancy
#set param(Topology)      "$TopologyPath/topo_10full.tcl" ;# 10 node random generated network fully meshed (1500)
#set param(Topology)      "$TopologyPath/topo_norge.tcl" ;# Unitnett backbone ... more or less
#set param(Topology)      "$TopologyPath/ingunn_topo_uninett.tcl" ;# Unitnett backbone, Ingunn Vestmoen's version
#set param(Topology)      "$TopologyPath/ingunn_topo_uninett_hamil.tcl" ;# Unitnett backbone supplemented to become hamiltonian
#set param(Topology)      "$TopologyPath/ingunn_topo_geant.tcl" ;# Unitnett backbone, Ingunn Vestmoen's version
#set param(Topology)      "$TopologyPath/poul_topo_telenor.tcl" ;# Telenor backbone, Poul Heegaard's version
#set param(Topology)      "$TopologyPath/poul_topo_telenor_core.tcl" ;# Telenor backbone, Poul Heegaard's version
set param(Topology)      "$TopologyPath/poul_topo_telenor4.tcl" ;# Telenor backbone, Poul Heegaard's version
#set param(Topology)      "$TopologyPath/uninett_topo_JNSM.tcl" 
#set param(Topology)      "$TopologyPath/uninett_topo_2007-10-22.tcl" ;# Uninett's topology anno 2007-10-22 05:07
#set param(Topology)      "$TopologyPath/uninett_topo_oct2007.tcl" ;# Uninett's topology anno october 2007. Based on web.
#set param(Topology)      "$TopologyPath/inet_ns_3037.tcl" ;# Inet generated AS topology

set param(StopToContinue)  0        ;# Flag indicating if simulation is to stop not terminate
set param(Finish)          1

set param(ProgressPeriod)   [expr $param(Finish) / 1000 ]  ;# Time periode for progress report
if { $param(ProgressPeriod) < 1  } {
    set param(ProgressPeriod) 1
}

# Trace params
set param(TraceFile)     "trace.tr"
set param(NamTraceFile)  "namtrace.nam"


# Load parameter settings form previous simulations run
#set param(LoadParam)    "parameters.log"


#################################################
# P R O C E D U R E S    A N D    C L A S S E S #
#################################################

#### Scenario Classes ####

# Base class
source $ClassLibPath/ceas-scenario.tcl

# CURRENT SCENARIO
Class CreateTopo_scenario -superclass CEAS_scenario

CreateTopo_scenario instproc init {param} {
    # Constructer

    # Add scenario title to param-array and run parent class constructer
    $self next "$param Scenario CreateTopo_scenario"
}

CreateTopo_scenario instproc init_components {} {
    # Prepare misc. component required in simulation
    
    # Do nothing.
}

CreateTopo_scenario instproc schedule_events {} {
    # List events to take place during the sim. scenario
    # Schedule events
    $self next                ;# (Call parent class instproc)
    $self instvar ns_ param_ node_ numnodes_ colors_ SimID_

    # Do nothing.
    
}    
    
###########
# M A I N #  
###########
#
# Create simulator instance
#
set ns [new Simulator] 

# Create scenario
new CreateTopo_scenario [array get param]

# Run simulation
puts "Running simulator..."
$ns run
