/*
 * Copyright (c) 2008 Q2S NTNU, Trondheim, Norway
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Port of the Swarm module developed by O. Wittner for ns-2.30.
 * Author: Laurent Paquereau <laurent.paquereau@q2s.ntnu.no>
 *
 * $Header$
 */

#ifndef _ceas_forwarding_unit_h
#define _ceas_forwarding_unit_h

#include "forwarding-unit.h"
#include "ceas-logger.h"
#include "ceas-network-layer-unit.h"

// Forward declaration
class CEASNetworkLayerUnit;

template<class _Key = int32_t,class _PathItemData = CEASPathItemData>
class CEASForwardingUnit : public ForwardingUnit {
  public:
    CEASForwardingUnit(CEASNetworkLayerUnit* networkLayerUnit)
      : ForwardingUnit(networkLayerUnit) {}
    inline CEASNetworkLayerUnit* networkLayerUnit()
      {return static_cast<CEASNetworkLayerUnit*>(networkLayerUnit_);}
    virtual CEASLogger<_Key,_PathItemData>* logger()
      {return static_cast<CEASLogger<_Key,_PathItemData>*>(logger_);}  
};

#endif


