/*
 * Copyright (c) 2008 Q2S NTNU, Trondheim, Norway
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Port of the Swarm module developed by O. Wittner for ns-2.30.
 * Author: Laurent Paquereau <laurent.paquereau@q2s.ntnu.no>
 *
 * $Header$
 */
 
#include"ceas-packet.h"

extern EmbeddedTcl CEAScommonTclCode;

 static class CEASHeaderClass : public PacketHeaderClass {
 public:
     CEASHeaderClass() : PacketHeaderClass("PacketHeader/CEAS", sizeof(hdr_ceas)) 
       {
         bind_offset(&hdr_ceas::offset_);
       }
     void export_offsets() 
       {
         field_offset("type_", OFFSET(hdr_ceas, type_));
       }
} class_CEASHeader;

int hdr_ceas::offset_;

extern "C" int Ceascommon_Init()
{
  // CEAS - used by hdr_cmn class for tracing purpose
  PT_CEAS = p_info::addPacket("ceas");
  CEASHeaderClass *shc = new CEASHeaderClass;
  shc->bind();
  CEAScommonTclCode.load();
  return 0;
}

extern "C" int Cygceascommon_Init()
{
  return Ceascommon_Init();
}
