/*
 * Copyright (c) 2008 Q2S NTNU, Trondheim, Norway
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Port of the Swarm module developed by O. Wittner for ns-2.30.
 * Author: Laurent Paquereau <laurent.paquereau@q2s.ntnu.no>
 *
 * $Header$
 */

#include <config.h>
#include "ceas-logger.h"

// OTcl linkage
static class CEASLoggerClass : public TclClass {
public:
  CEASLoggerClass() : TclClass("Logger/CEAS") {}
  TclObject* create(int argc, const char*const* argv) {
      if (argc != 4)
        { // 4 <=> 0 parameter for the the constructor
          fprintf(stderr,
                  "CEASLoggerClass::%s: Invalid number of parameters.\n",
                  __FUNCTION__);
          abort();
        }
      return (CEASLogger<>::instance());
  }
} class_CEASLogger;

template<>
char*
CEASLogger<>::key2str(int32_t& key)
{
    char* keystr = 0;
    char str[32];
    str[0]='\0';
    sprintf(str,"id%d",key);
    keystr = new char[strlen(str)+1];
    strcpy(keystr,str);
    return(keystr);
}

template<>
int32_t
CEASLogger<>::pheroId(int32_t& key)
{
    return key;
}

template<>
char*
CEASLogger<>::pheroId2str(CEASLogger<>*,int32_t pheroId)
{
    char* phero_id_str = 0;
    char str[32];
    str[0]='\0';
    sprintf(str,"%d",pheroId);
    phero_id_str = new char[strlen(str)+1];
    strcpy(phero_id_str,str);
    return(phero_id_str);
}

/*! \param str species */
template<> void
CEASLogger<>::str2key(int32_t& key,char* str)
{
    int32_t id;
    if (sscanf(str,"%d",&id) != 1)
      {
        fprintf(stderr,
                "CEASLogger<>::%s: Invalid key string format (%s)\n",
                __FUNCTION__,str);
        abort();
      }
    key = id;
}
