/*
 * Copyright (c) 2008 Q2S NTNU, Trondheim, Norway
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Port of the Swarm module developed by O. Wittner for ns-2.30.
 * Author: Laurent Paquereau <laurent.paquereau@q2s.ntnu.no>
 *
 * $Header$
 */
 
#include <node.h>
#include "ceas-neighbour-information-base.h"

// OTcl linkage

static class CEASNeighbourInformationBaseClass : public TclClass {
public:
    CEASNeighbourInformationBaseClass() 
      : TclClass("NeighbourInformationBase/CEAS") {}
    TclObject* create(int argc, const char*const* argv)
    {
        if (argc != 5)
          { // 5 <=> 1 parameter for the the constructor
            fprintf(stderr,"CEASNeighbourInformationBaseClass::%s: "\
                    "Invalid number of parameters.\n",__FUNCTION__);
            abort();
          }
        Node* node = dynamic_cast<Node*>(TclObject::lookup(argv[4]));
        if (!node)
          { // lookup failed
            fprintf(stderr,"CEASNeighbourInformationBaseClass::%s: "\
                    "Lookup failed (node)(%s)\n",__FUNCTION__,argv[5]);
            abort();
          }
        return (new CEASNeighbourInformationBase(node));
    }
} class_CEASNeighbourInformationBase;
