/*
 * Copyright (c) 2008 Q2S NTNU, Trondheim, Norway
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Port of the Swarm module developed by O. Wittner for ns-2.30.
 * Author: Laurent Paquereau <laurent.paquereau@q2s.ntnu.no>
 *
 * $Header$
 */

#include"ceas-packet.h"

CEAS_info ceas_info;
const char** CEAS_info::name_;
unsigned int CEAS_info::nCEAS_ = 0;
packet_t PT_CEAS;
AppDataType CEAS_DATA;

/*! Add name in the name map */
int
CEAS_info::add(const char* name)
{
    if(!nCEAS_) initName();
    int i = nCEAS_-1;
    CEAS_NONE = nCEAS_;
    initName();
    name_[i] = name;
    return i;
}

// Implementation for the default template parameter
template<> void
CEASData<CEASPathItemData>::push(nsaddr_t addr,NeighbourEntry* next)
{
    if (next)
      { // ant is not at destination
        CEASPathItemData d(next->key());
        path_->push_back(pair<nsaddr_t,CEASPathItemData>(addr,d));
        // accumulate cost
        L_ += next->costTo();
      }
    else
      { // ant is at destination
        NeighbourKey unkn_key(UNKN_ADDRESS,UNKN_IFACE.value(),UNKN_CHANNEL);
        CEASPathItemData d(unkn_key);
        path_->push_back(pair<nsaddr_t,CEASPathItemData>(addr,d));
      }
}
                                                                                                                 
