/*
 * Copyright (c) 2008 Q2S NTNU, Trondheim, Norway
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Port of the Swarm module developed by O. Wittner for ns-2.30.
 * Author: Laurent Paquereau <laurent.paquereau@q2s.ntnu.no>
 *
 * $Header$
 */
 
#include <point-to-point-interface.h>
#include "ceas-wired-neighbour.h"

//! Constructor
CEASWiredNeighbour::CEASWiredNeighbour(PointToPointInterface* iface)
  : NeighbourEntry(UNKN_ADDRESS,iface,0)
{
    address_ = interface()->getNeighbourAddress();
}

//! Destructor
CEASWiredNeighbour::~CEASWiredNeighbour()
{
}

//! \returns the link propagation delay to the neighbour
double
CEASWiredNeighbour::costTo()
{
    return interface()->getLinkPropagationDelay();
}

bool
CEASWiredNeighbour::isReachable()
{
    return (interface()->isUp() &&      // the interface is up
            interface()->getLink() &&   // there is a link in this direction
            interface()->isLinkUp());   // the link is up
}
