dnl Copyright (c) 2008 Q2S NTNU, Trondheim, Norway
dnl All rights reserved.
dnl
dnl This program is free software; you can redistribute it and/or modify
dnl it under the terms of the GNU General Public License version 2 as
dnl published by the Free Software Foundation;
dnl
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
dnl GNU General Public License for more details.
dnl
dnl You should have received a copy of the GNU General Public License
dnl along with this program; if not, write to the Free Software
dnl Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
dnl
dnl Author: Laurent Paquereau <laurent.paquereau@q2s.ntnu.no>
dnl
dnl $Header$

dnl --with-ceas-common option. This is to be able to specify a given CEAS common directory

AC_DEFUN([AC_CEASCOMMONDIR], [

CEASCOMMONDIR="$NSALLINONEDIR/CEAS/libs/common"

AC_ARG_WITH([ceas-common],
	[AC_HELP_STRING([--with-ceas-common=<dir>],
			[use ceas-common src in <dir>/src (default is guessed from NSALLINONEDIR)])],
	[
	    if test ! -d $withval 
		then
		AC_MSG_ERROR([swarn common dir $withval is not valid])
	    else	
		CEASCOMMONDIR=$withval
	    fi
	])

if test ! -d $CEASCOMMONDIR ; then
	AC_MSG_ERROR([you must specify the path to ceas common header files using --with-ceas-common=<dir>])
fi

AC_MSG_RESULT([setting CEASCOMMONDIR to $CEASCOMMONDIR])

NS_CPPFLAGS="$NS_CPPFLAGS -I$CEASCOMMONDIR/src"
CEAS_COMMON_DISTCHECK_CONFIGURE_FLAGS="--with-ceas-common=$CEASCOMMONDIR"
AC_SUBST(CEAS_COMMON_DISTCHECK_CONFIGURE_FLAGS)

AC_SUBST(NS_CPPFLAGS)

dnl temporarily add NS_CPPFLAGS to CPPFLAGS
BACKUP_CPPFLAGS="$CPPFLAGS"
CPPFLAGS="$CPPFLAGS $NS_CPPFLAGS"

AC_LANG_PUSH(C++)

AC_MSG_CHECKING([for CEAS common header files])

AC_PREPROC_IFELSE(
        [AC_LANG_PROGRAM([[
		#include<ceas-utils.h>
                ]],[[
                ]]  )],
        [AC_MSG_RESULT([ok])],
        [
          AC_MSG_RESULT([ko])
          AC_MSG_ERROR([CEAS common header files not found in $CEASCOMMONDIR/src
                  Specify the path to CEAS common using --with-ceas-common=PATH])
        ])


dnl Restoring to the initial value
CPPFLAGS="$BACKUP_CPPFLAGS"

AC_LANG_POP(C++)

])
