dnl Copyright (c) 2008 Q2S NTNU, Trondheim, Norway
dnl All rights reserved.
dnl
dnl This program is free software; you can redistribute it and/or modify
dnl it under the terms of the GNU General Public License version 2 as
dnl published by the Free Software Foundation;
dnl
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
dnl GNU General Public License for more details.
dnl
dnl You should have received a copy of the GNU General Public License
dnl along with this program; if not, write to the Free Software
dnl Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
dnl
dnl Author: Laurent Paquereau <laurent.paquereau@q2s.ntnu.no>
dnl
dnl $Header$

AC_DEFUN([AC_SANITY_CHECK], [

dnl temporarily add NS_CPPFLAGS to CPPFLAGS
BACKUP_CPPFLAGS="$CPPFLAGS"
CPPFLAGS="$CPPFLAGS $NS_CPPFLAGS "

AC_LANG_PUSH(C++)

AC_MSG_CHECKING([for otcl.h])
AC_PREPROC_IFELSE(
	[AC_LANG_PROGRAM([[
		#include<otcl.h>
		]],[[
		]]  )],
	[AC_MSG_RESULT([ok])],
	[
		AC_MSG_RESULT([could not find otcl.h!])
		AC_MSG_ERROR([use --with-otcl=<dir> to specify the path to the otcl directory])
	])

AC_MSG_CHECKING([for tclcl.h])
AC_PREPROC_IFELSE(
	[AC_LANG_PROGRAM([[
		#include<tclcl.h>
		]],[[
		]]  )],
	[AC_MSG_RESULT([ok])],
	[
		AC_MSG_RESULT([could not find tclcl.h!])
		AC_MSG_ERROR([use --with-tclcl=<dir> to specify the path to the tclcl directory])
	])

AC_MSG_CHECKING([for ns-allinone installation])
AC_PREPROC_IFELSE(
	[AC_LANG_PROGRAM([[
		#include<tcl.h>
		#include<otcl.h>
		#include<tclcl.h>
		#include<packet.h>
		Packet* p; 
		]],[[
		p = new packet;
		delete p;
		]]  )],
	[AC_MSG_RESULT([ok])],
	[
		AC_MSG_RESULT([FAILED!])
		AC_MSG_ERROR([Could not find ns headers. use --with-ns-allinone or --with-ns options])
	])

AC_MSG_CHECKING([for dynamic libraries support in ns])
AC_COMPILE_IFELSE(
	[AC_LANG_PROGRAM([[
		#include<packet.h>
		]],[[
		p_info::addPacket("test");
		]]  )],
	[AC_MSG_RESULT([ok])],
	[
		AC_MSG_RESULT([ko])
		AC_MSG_ERROR([The ns installation in $NSDIR does not support dynamic libraries.
		    Dynamic libraries are supported natively in ns-2.33 and newer versions. 
		    Older versions need to be patched. Check: http://www.dei.unipd.it/wdyn/?IDsezione=3970])
	])

dnl Restoring to the initial value
CPPFLAGS="$BACKUP_CPPFLAGS"

AC_LANG_POP(C++)

AC_ARG_VAR([TCL2CPP],[tcl2c++ executable])
AC_PATH_PROG([TCL2CPP],[tcl2c++],[none],[$PATH:$TCLCL_PATH])
if test "x$TCL2CPP" = "xnone" ;    then
	AC_MSG_ERROR([could not find tcl2c++])
fi
])
