/*
 * Copyright (c) 2008 Q2S NTNU, Trondheim, Norway
 *  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Port of the Swarm module developed by O. Wittner for ns-2.30.
 * Author: Laurent Paquereau <laurent.paquereau@q2s.ntnu.no>
 *
 * $Header$
 */

#include <simulator.h>
#include "ceas-wired-neighbour.h"
#include "plain-ceas-network-layer-unit.h"
#include "plain-ceas-routing-unit.h"
#include "plain-ceas-forwarding-unit.h"

ceas_t CEAS_PLAIN;

// OTcl linkage

static class Plain_CEASNetworkLayerUnitClass : public TclClass {
public:
  Plain_CEASNetworkLayerUnitClass()
    : TclClass("NetworkLayerUnit/CEAS/Plain") {}
  TclObject* create(int argc, const char*const* argv) 
  {
      if (argc != 5)
        { // 5 <=> 1 parameter for the the constructor
          fprintf(stderr,
                  "Plain_CEASNetworkLayerUnitClass::%s: "  \
                  "Invalid number of parameters.\n",
                  __FUNCTION__);
          abort();
        }
      Node* node = static_cast<Node*>(TclObject::lookup(argv[4]));
      if (!node)
        { // lookup failed
          fprintf(stderr,"Plain_CEASNetworkLayerUnitClass::%s: "\
                  "Lookup failed (node)(%s)\n",__FUNCTION__,argv[4]);
          abort();
        }
      return (new Plain_CEASNetworkLayerUnit(node));
  }
} class_Plain_CEASNetworkLayerUnit;

//! Constructor

Plain_CEASNetworkLayerUnit::Plain_CEASNetworkLayerUnit(Node* node) 
  : CEASNetworkLayerUnit(node)
{
     
	routingUnit_ = new Plain_CEASRoutingUnit(this);
	forwardingUnit_ = new Plain_CEASForwardingUnit(this);
	
}
