# ST 23-02-09
#
# Created using Matthew B. Doar's `tiers` topology generator with parameters:
#   tiers 0 0 0 00 0 0 4 0 0 0 0 000
#
#
proc create_net {} {
    global ns_
    global NumNodes
    global node
    global network_layer_type
    global network_layer_unit
    
    set ns_ [Simulator instance]
    
    set NumNodes 11
    set i 0
    while {$i < $NumNodes } {
	set nodes_($i) [$ns_ node]
	set network_layer_units_($i) [new NetworkLayerUnit/$network_layer_type $nodes_($i)]
	incr i
    }

     	# Link 0 to 3 orient right-down
	set iface_(0,3) [$nodes_(0) add-interface PointToPoint $network_layer_units_(0)]
	set iface_(3,0) [$nodes_(3) add-interface PointToPoint $network_layer_units_(3)]	
	$ns_ add-duplex-link $iface_(0,3) $iface_(3,0) 100Mb 1ms DropTail
	$ns_ duplex-link-op $nodes_(0) $nodes_(3) orient right-down

	# Link 1 to 3 orient right
	set iface_(1,3) [$nodes_(1) add-interface PointToPoint $network_layer_units_(1)]
	set iface_(3,1) [$nodes_(3) add-interface PointToPoint $network_layer_units_(3)]	
	$ns_ add-duplex-link $iface_(1,3) $iface_(3,1) 100Mb 1ms DropTail
	$ns_ duplex-link-op $nodes_(1) $nodes_(3) orient right
	
	# Link 2 to 3 orient right-up
	set iface_(2,3) [$nodes_(2) add-interface PointToPoint $network_layer_units_(2)]
	set iface_(3,2) [$nodes_(3) add-interface PointToPoint $network_layer_units_(3)]	
	$ns_ add-duplex-link $iface_(2,3) $iface_(3,2) 100Mb 1ms DropTail
	$ns_ duplex-link-op $nodes_(2) $nodes_(3) orient right-up

	# Link 3 to 4 orient right
	set iface_(3,4) [$nodes_(3) add-interface PointToPoint $network_layer_units_(3)]
	set iface_(4,3) [$nodes_(4) add-interface PointToPoint $network_layer_units_(4)]	
	$ns_ add-duplex-link $iface_(3,4) $iface_(4,3) 100Mb 1ms DropTail
	$ns_ duplex-link-op $nodes_(3) $nodes_(4) orient right
	
	# Link 4 to 5 orient right
	set iface_(4,5) [$nodes_(4) add-interface PointToPoint $network_layer_units_(4)]
	set iface_(5,4) [$nodes_(5) add-interface PointToPoint $network_layer_units_(5)]	
	$ns_ add-duplex-link $iface_(4,5) $iface_(5,4) 100Mb 1ms DropTail
	$ns_ duplex-link-op $nodes_(4) $nodes_(5) orient right

	# Link 5 to 6 orient right-up
	set iface_(5,6) [$nodes_(5) add-interface PointToPoint $network_layer_units_(5)]
	set iface_(6,5) [$nodes_(6) add-interface PointToPoint $network_layer_units_(6)]	
	$ns_ add-duplex-link $iface_(5,6) $iface_(6,5) 100Mb 1ms DropTail
	$ns_ duplex-link-op $nodes_(5) $nodes_(6) orient right-up

	# Link 5 to 7 orient right
	set iface_(5,7) [$nodes_(5) add-interface PointToPoint $network_layer_units_(5)]
	set iface_(7,5) [$nodes_(7) add-interface PointToPoint $network_layer_units_(7)]	
	$ns_ add-duplex-link $iface_(5,7) $iface_(7,5) 100Mb 1ms DropTail
	$ns_ duplex-link-op $nodes_(5) $nodes_(7) orient right

	# Link 5 to 8 orient right-down
	set iface_(5,8) [$nodes_(5) add-interface PointToPoint $network_layer_units_(5)]
	set iface_(8,5) [$nodes_(8) add-interface PointToPoint $network_layer_units_(8)]	
	$ns_ add-duplex-link $iface_(5,8) $iface_(8,5) 100Mb 1ms DropTail
	$ns_ duplex-link-op $nodes_(5) $nodes_(8) orient right-down

	# Link 5 to 9 orient left-down
	set iface_(5,9) [$nodes_(5) add-interface PointToPoint $network_layer_units_(5)]
	set iface_(9,5) [$nodes_(9) add-interface PointToPoint $network_layer_units_(9)]	
	$ns_ add-duplex-link $iface_(5,9) $iface_(9,5) 100Mb 1ms DropTail
	$ns_ duplex-link-op $nodes_(5) $nodes_(9) orient left-down

	# Link 9 to 10 orient left
	set iface_(9,10) [$nodes_(9) add-interface PointToPoint $network_layer_units_(9)]
	set iface_(10,9) [$nodes_(10) add-interface PointToPoint $network_layer_units_(10)]	
	$ns_ add-duplex-link $iface_(9,10) $iface_(10,9) 100Mb 1ms DropTail
	$ns_ duplex-link-op $nodes_(9) $nodes_(10) orient left

	# Link 10 to 3 orient left-up
	set iface_(10,3) [$nodes_(10) add-interface PointToPoint $network_layer_units_(10)]
	set iface_(3,10) [$nodes_(3) add-interface PointToPoint $network_layer_units_(3)]	
	$ns_ add-duplex-link $iface_(10,3) $iface_(3,10) 100Mb 1ms DropTail
	$ns_ duplex-link-op $nodes_(10) $nodes_(3) orient left-up

	
    
    array set node [array get nodes_]
    array set network_layer_unit [array get network_layer_units_]
    
}
