# ST 23-02-09
#
# Created using Matthew B. Doar's `tiers` topology generator with parameters:
#   tiers 0 0 0 00 0 0 4 0 0 0 0 000
#
#
proc create_net {} {
    global ns_
    global NumNodes
    global node
    global network_layer_type
    global network_layer_unit
    
    set ns_ [Simulator instance]
    
    set NumNodes 12
    set i 0
    while {$i < $NumNodes } {
	set nodes_($i) [$ns_ node]
	set network_layer_units_($i) [new NetworkLayerUnit $nodes_($i)]
	incr i
    }

     	# Link 1 to 0 orient left-down
	set iface_(1,0) [$nodes_(1) add-interface PointToPoint $network_layer_units_(1)]
   	set iface_(0,1) [$nodes_(0) add-interface PointToPoint $network_layer_units_(0)]
	$ns_ add-duplex-link $iface_(1,0) $iface_(0,1) 1Mb 10ms DropTail
	$ns_ duplex-link-op $nodes_(1) $nodes_(0) orient left-down
	
	# Link 1 to 3 orient right
	set iface_(1,3) [$nodes_(1) add-interface PointToPoint $network_layer_units_(1)]
   	set iface_(3,1) [$nodes_(3) add-interface PointToPoint $network_layer_units_(3)]
	$ns_ add-duplex-link $iface_(1,3) $iface_(3,1) 1Mb 10ms DropTail
	$ns_ duplex-link-op $nodes_(1) $nodes_(3) orient right
	
	# Link 3 to 2 orient left-down
	set iface_(3,2) [$nodes_(3) add-interface PointToPoint $network_layer_units_(3)]
   	set iface_(2,3) [$nodes_(2) add-interface PointToPoint $network_layer_units_(2)]
	$ns_ add-duplex-link $iface_(3,2) $iface_(2,3) 1Mb 10ms DropTail
	$ns_ duplex-link-op $nodes_(3) $nodes_(2) orient left-down
	
	# Link 3 to 5 orient right
	set iface_(3,5) [$nodes_(3) add-interface PointToPoint $network_layer_units_(3)]
    	set iface_(5,3) [$nodes_(5) add-interface PointToPoint $network_layer_units_(5)]
    	$ns_ add-duplex-link $iface_(3,5) $iface_(5,3) 1Mb 10ms DropTail
  	$ns_ duplex-link-op $nodes_(3) $nodes_(5) orient right
	
	# Link 5 to 4 orient left-down 
    	set iface_(5,4) [$nodes_(5) add-interface PointToPoint $network_layer_units_(5)]
   	set iface_(4,5) [$nodes_(4) add-interface PointToPoint $network_layer_units_(4)]
	$ns_ add-duplex-link $iface_(5,4) $iface_(4,5) 1Mb 10ms DropTail
	$ns_ duplex-link-op $nodes_(5) $nodes_(4) orient left-down
    
	# Link 6 to 7 orient right-up
	set iface_(6,7) [$nodes_(6) add-interface PointToPoint $network_layer_units_(6)]
   	set iface_(7,6) [$nodes_(7) add-interface PointToPoint $network_layer_units_(7)]
	$ns_ add-duplex-link $iface_(6,7) $iface_(7,6) 1Mb 10ms DropTail
	$ns_ duplex-link-op $nodes_(6) $nodes_(7) orient right-up
	
	# Link 0 to 6 orient down
	set iface_(0,6) [$nodes_(0) add-interface PointToPoint $network_layer_units_(0)]
   	set iface_(6,0) [$nodes_(6) add-interface PointToPoint $network_layer_units_(6)]
	$ns_ add-duplex-link $iface_(0,6) $iface_(6,0) 1Mb 10ms DropTail
	$ns_ duplex-link-op $nodes_(0) $nodes_(6) orient down
	
	
	# Link 1 to 7 orient down
	set iface_(1,7) [$nodes_(1) add-interface PointToPoint $network_layer_units_(1)]
   	set iface_(7,1) [$nodes_(7) add-interface PointToPoint $network_layer_units_(7)]
	$ns_ add-duplex-link $iface_(1,7) $iface_(7,1) 1Mb 10ms DropTail
	$ns_ duplex-link-op $nodes_(1) $nodes_(7) orient down
	
	# Link 7 to 9 orient right
	set iface_(7,9) [$nodes_(7) add-interface PointToPoint $network_layer_units_(7)]
   	set iface_(9,7) [$nodes_(9) add-interface PointToPoint $network_layer_units_(9)]
	$ns_ add-duplex-link $iface_(7,9) $iface_(9,7) 1Mb 10ms DropTail
	$ns_ duplex-link-op $nodes_(7) $nodes_(9) orient right
   
	# Link 8 to 9 orient right-up
	set iface_(8,9) [$nodes_(8) add-interface PointToPoint $network_layer_units_(8)]
    	set iface_(9,8) [$nodes_(9) add-interface PointToPoint $network_layer_units_(9)]
    	$ns_ add-duplex-link $iface_(8,9) $iface_(9,8) 1Mb 10ms DropTail
    	$ns_ duplex-link-op $nodes_(8) $nodes_(9) orient right-up

   	# Link 10 to 9 orient left-up
	set iface_(10,9) [$nodes_(10) add-interface PointToPoint $network_layer_units_(10)]
    	set iface_(9,10) [$nodes_(9) add-interface PointToPoint $network_layer_units_(9)]
    	$ns_ add-duplex-link $iface_(10,9) $iface_(9,10) 1Mb 10ms DropTail
    	$ns_ duplex-link-op $nodes_(10) $nodes_(9) orient left-up

   	# Link 2 to 8 orient down
	set iface_(2,8) [$nodes_(2) add-interface PointToPoint $network_layer_units_(2)]
    	set iface_(8,2) [$nodes_(8) add-interface PointToPoint $network_layer_units_(8)]
    	$ns_ add-duplex-link $iface_(2,8) $iface_(8,2) 1Mb 10ms DropTail
    	$ns_ duplex-link-op $nodes_(2) $nodes_(8) orient down
 	
    	# Link 3 to 9 orient down
	set iface_(3,9) [$nodes_(3) add-interface PointToPoint $network_layer_units_(3)]
    	set iface_(9,3) [$nodes_(9) add-interface PointToPoint $network_layer_units_(9)]
    	$ns_ add-duplex-link $iface_(3,9) $iface_(9,3) 1Mb 10ms DropTail
    	$ns_ duplex-link-op $nodes_(3) $nodes_(9) orient down
	
	# Link 8 to 6 orient left
	set iface_(8,6) [$nodes_(8) add-interface PointToPoint $network_layer_units_(8)]
    	set iface_(6,8) [$nodes_(6) add-interface PointToPoint $network_layer_units_(6)]
    	$ns_ add-duplex-link $iface_(8,6) $iface_(6,8) 1Mb 10ms DropTail
    	$ns_ duplex-link-op $nodes_(8) $nodes_(6) orient left
	
	# Link 10 to 8 orient left
	set iface_(10,8) [$nodes_(10) add-interface PointToPoint $network_layer_units_(10)]
    	set iface_(8,10) [$nodes_(8) add-interface PointToPoint $network_layer_units_(8)]
    	$ns_ add-duplex-link $iface_(10,8) $iface_(8,10) 1Mb 10ms DropTail
    	$ns_ duplex-link-op $nodes_(10) $nodes_(8) orient left

    	# Link 10 to 11 orient right-up
	set iface_(10,11) [$nodes_(10) add-interface PointToPoint $network_layer_units_(10)]
    	set iface_(11,10) [$nodes_(11) add-interface PointToPoint $network_layer_units_(11)]
    	$ns_ add-duplex-link $iface_(10,11) $iface_(11,10) 1Mb 10ms DropTail
    	$ns_ duplex-link-op $nodes_(10) $nodes_(11) orient right-up
 
	# Link 4 to 10 orient down
	set iface_(4,10) [$nodes_(4) add-interface PointToPoint $network_layer_units_(4)]
    	set iface_(10,4) [$nodes_(10) add-interface PointToPoint $network_layer_units_(10)]
    	$ns_ add-duplex-link $iface_(4,10) $iface_(10,4) 1Mb 10ms DropTail
    	$ns_ duplex-link-op $nodes_(4) $nodes_(10) orient down   
    
	# Link 5 to 11 orient down
	set iface_(5,11) [$nodes_(5) add-interface PointToPoint $network_layer_units_(5)]
	set iface_(11,5) [$nodes_(11) add-interface PointToPoint $network_layer_units_(11)]
	$ns_ add-duplex-link $iface_(5,11) $iface_(11,5) 1Mb 10ms DropTail
	$ns_ duplex-link-op $nodes_(5) $nodes_(11) orient down


    
    array set node [array get nodes_]
    array set network_layer_unit [array get network_layer_units_]
    
}
